package edu.njit.decaf3.helper;

import com.google.gson.Gson;
import edu.njit.decaf3.structure.Simulation;

import java.io.File;
import java.io.FileInputStream;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;

/**
 * DECAF - Dependability Evaluator of Cascading Failures Revision 3
 *
 * @author Sashank Tadepalli, Mihir Sanghavi
 *
 */
public class JSON {
    /**
     *
     * @param inputFile
     * @return
     * @throws Exception
     */
    public static Simulation parse(File inputFile) throws Exception{
        Simulation sim;
        Gson g = new Gson();
        FileInputStream stream = new FileInputStream(inputFile);
        FileChannel fc = stream.getChannel();
        MappedByteBuffer bb = fc.map(FileChannel.MapMode.READ_ONLY, 0, fc.size());
        String jsonString = Charset.defaultCharset().decode(bb).toString();

        stream.close();

        sim = new Simulation();
        sim = g.fromJson(jsonString, sim.getClass());
        if(sim == null)
            throw new Exception("Simulation object cannot be loaded.");
        return sim;
    }

    /**
     *
     * @param i
     * @return
     * @throws Exception
     */
    public static Simulation parse(String i) throws Exception{
        return parse(new File(i));
    }
}
